/**********************************************************
TReaderE2  3.0 for E2 
Written  by Strelok Vlad Kolerts
19/01/2009
Email: admin@mobsk.org.ua
ICQ: 497123239

Thanks to Lasly and kidscracker
***********************************************************/
#include "TEditor.h"

class TEditor;

TEditor::TEditor() : ZKbMainWidget(NULL,NULL , "TEditor" , 0)
	{
		isMarked = false;
		m_iMarkStartX =  -1 ;
		m_iMarkStartY = -1 ;
		
		QVBoxLayout* layout = getVBoxLayout();
		layout->setMargin(0);
		
		softKey = new ZSoftKey(NULL , this , this);
		
		EditInfo = new ZAppInfoArea(this, "ZAppInfoArea", 0, (ZSkinService::WidgetClsID)0);
		EditInfo->setInputArea();
		
		panel = new ZScrollPanel(this , NULL , 0,(ZSkinService::WidgetClsID)0);
		panel->resize(240,320-EditInfo->height()/*-softKey->height()*/);
		
		memo = new ZMultiLineEdit(panel, false, 1, "ZMultiLineEdit");
		memo->setFixedWidth( 240 );
		memo->setFixedHeight( 320-EditInfo->height()/*-softKey->height()*/ );
		memo->setUnderline( false );
		memo->setSizePolicy( QSizePolicy ( QSizePolicy::Expanding, QSizePolicy::Expanding ) );
		memo->setVerScrollBar( true, false );
		memo->setMaxLineLength(-1);
		memo->setAutoUpdate(true);
		memo->undoAvailable(true);
		memo->setAutoFixedHeight(true);
		//memo->setFontPercent( DEFAULT_EDIT_FONT_SIZE );
		//memo->setInsertionMethod(  ZMultiLineEdit::atPosNoSelected); 
		//memo->setWordWrap(ZMultiLineEdit::NoWrap);
		
		layout->addWidget(panel);
		
		setAppInfoArea(EditInfo);
		setSoftKey(softKey);
		softKey->hide();
		fullScreenModeChanged(true);
	}
	
TEditor::~TEditor()
{
}
	
	void TEditor::addText(QString text)
	{
		atEnd();
		memo->insert( text );
	}
	
	void TEditor::SetText(QString text)
	{
		memo->setText( text );
	}
	
	void TEditor::MarkBegin()
	{
		memo->getCursorPosition( &m_iMarkStartX, &m_iMarkStartY );
		isMarked = true;
	}

	void TEditor::MarkEnd()
	{
		if( -1 != m_iMarkStartX )  
		{ 
			int iSelEndX = 0;
			int iSelEndY = 0;
			memo->getCursorPosition( &iSelEndX, &iSelEndY );
			memo->setSelection( m_iMarkStartX, m_iMarkStartY, iSelEndX, iSelEndY );
			m_iMarkStartX = m_iMarkStartY = -1;
			isMarked = false;
		}    
	}

	void TEditor::atBegin()
	{
		memo->setCursorPosition(0,0, false);
	}


	void TEditor::atEnd()
	{
		int x = memo->getLineCount() - 1;
		int y = memo->textLine( x ).length();
		memo->setCursorPosition( x, y, false );  
	}


	void TEditor::keyPressEvent ( QKeyEvent* e )
	{
	  
	 
		switch ( e->key() ) 
		{		    
		    case 4118: // +
				memo->pageUp(false);
		    break;
		    
		    case 4119: // -
			    memo->pageDown(false);
		    break;
		    
		    case 4144: // 
				if ( ! isMarked) { MarkBegin();  }  else   { MarkEnd(); }
		    break;
			
			case 4171:
				//undo();
			    BlockCopy();
		    break;
			
			case 4172:
				//redo();
			    memo->paste();			   
		    break;
		    
		    case 4114: // 	    
			    if ( e->isAutoRepeat()) memo->cursorWordBackward(isMarked );  
			    else  					memo->cursorLeft(isMarked, true); 
		    break;
			
		    case 4115: //
				memo->cursorUp(isMarked);
		    break; 
		    
		    case 4116: //  
			    if ( e->isAutoRepeat()) memo->cursorWordForward(isMarked  );  
			    else  					memo->cursorRight(isMarked, true);
		    break; 
			
		    case 4117: // 
				memo->cursorDown(isMarked);
		    break; 
		    
		    case 4146: //  - 
			    isMarked =false;
			    m_iMarkStartX = m_iMarkStartY = -1;
			    TEditor::keyPressEvent ( e );
		    break;
			
			case 4145://(exit)
				this->hide();
			break;
		}  
  	}

	void TEditor::BlockCopy()
	{
		isMarked =false;
		m_iMarkStartX = m_iMarkStartY = -1;
		memo->copy();
	}

	void TEditor::BlockCut()
	{
		isMarked =false;
		m_iMarkStartX = m_iMarkStartY = -1;
		memo->cut();
	}
