/**********************************************************
TReaderE2  3.0 for E2 
Written  by Strelok Vlad Kolerts
19/01/2009
Email: admin@mobsk.org.ua
ICQ: 497123239

Thanks to Lasly and kidscracker
***********************************************************/

#include "TReader.h"
#include <KString.h>

//end ---кодировки

TReader::TReader():ZKbMainWidget(NULL,NULL , "ZMainWidget" , 0)
	{	
		setFullScreenMode(true, true);	
		setBackgroundColor( bg_color );
		resize( 240, 320 );
		
		tEditor = new TEditor();
		tEditor->hide();
		//editor_add=false;
		
		path=getProgramDir(QString ( qApp->argv() [0] ));
		p_field=new QPixmap( 240, 320 );
		about_icon = QPixmap(path+"TReader.png");
		y=0;
		x=5;
		line_vis=1;
		font_size=13;
		font_codec=0;
		font_bold=25;
		font_ital=false;
		bg_color=QColor(250,250,250);
		font_color=QColor(0,0,0);
		rotate_90=false;
		rotate_chk=true;
		
		num_line[0]=num_line[1]=1;
		
		fontChange(true);
		
		inside_type=0;
		
		line_up=false;
		line_down=false;
		move_left=false;
		move_right=false;
		edit=false;
		exit=false;
		exit_count=20;
		
		open=true;
		FileName=qApp->argv()[2];
		
		QPainter	p;
		QWMatrix matrix;
		
		QString font_path=getFmDir()+"res/font.ttf";
		QFontFactory *factory = qt_fontmanager->factories.at(0);
		QDiskFont *qdf = new QDiskFont(factory, "KolertsFont", false, 25, 0, "s", font_path);
		QDiskFont *qdf_b = new QDiskFont(factory, "KolertsFont", false, 87, 0, "s", font_path);
		QDiskFont *qdf_i = new QDiskFont(factory, "KolertsFont", true, 25, 0, "s", font_path);
		QDiskFont *qdf_ib = new QDiskFont(factory, "KolertsFont", true, 87, 0, "s", font_path);
		qt_fontmanager->diskfonts.append(qdf);
		qt_fontmanager->diskfonts.append(qdf_b);
		qt_fontmanager->diskfonts.append(qdf_i);
		qt_fontmanager->diskfonts.append(qdf_ib);
		QFontDatabase::qwsAddDiskFont(qdf);
		QFontDatabase::qwsAddDiskFont(qdf_b);
		QFontDatabase::qwsAddDiskFont(qdf_i);
		QFontDatabase::qwsAddDiskFont(qdf_ib);
		
		
		timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), SLOT(action()) );		
		timer->start( 50 );
	}	


TReader::~TReader()
	{
	}
	
void TReader::TextBrowse()
	{
		p.begin( p_field ,this);
		p.setPen(bg_color);
		p.setBrush(bg_color);
		p.drawRect(0, 0, 240, 320);	
		p.setPen(font_color);
		p.drawRect(1, 1, 238, 318);	
		p.setClipRect(1, 1, 238, 318);	
		
		QFont ffont("KolertsFont", font_size, font_bold, font_ital);
		p.setFont(ffont);
		QPoint point;
		QString ptext;
		
		if(rotate_90)	
		{
			p.setWorldMatrix(matrix);
		}
		
		for(int i=0;i<line_vis;i++)
		{				
			if(y+i<num_line[font_codec])
			{
				point=QPoint(x, line_step+i*line_step);
				
				ptext=text[font_codec][y+i];
				
				p.drawText(point, ptext, -1);
			}
		}
		//p.setPen(Qt::red);
		//p.drawText(20, 20, QString("num_line=%1 end_line=%2").arg(num_line).arg(y+line_vis), -1, QPainter::RTL);
		
		//scrolbar
		if(!rotate_90)
		{
			p.drawRect(236, 1, 3, 318);
			scroll_pos=y*318/num_line[font_codec];		
			p.drawLine(237, 1+scroll_pos, 237, 1+scroll_pos+scroll_size);
		}
		else
		{
			p.drawRect(316, 1, 3, 238);
			scroll_pos=y*238/num_line[font_codec];
			p.drawLine(317, 1+scroll_pos, 317, 1+scroll_pos+scroll_size);
		}
		p.end();
		
		bitBlt( this, 0, 0, p_field );
	}

void TReader::lineUp()
	{
		if(y>0) y=y-1;
	}
	
void TReader::lineDown()
	{
		if(num_line[font_codec]>y+line_vis)
			y=y+1;
		
		if(num_line[font_codec]<y+line_vis)
		{
			if(num_line[font_codec]>line_vis)
				y=num_line[font_codec]-line_vis;
			else
				y=0;
		}
	}
	
void TReader::moveLeft()
	{
		if(inside_type==0)
			if(x<5) x=x+10;
	}
	
void TReader::moveRight()
	{
		if(inside_type==0)
			x=x-10;
	}
// ---------------
void TReader::pageUp()
	{
		if(y>0) y=y-line_vis+1;
		if(y<0) y=0;
	}
	
void TReader::pageDown()
	{
		if(num_line[font_codec]>y+line_vis)
			y=y+line_vis-1;
		
		if(num_line[font_codec]<y+line_vis)
		{
			if(num_line[font_codec]>line_vis)
				y=num_line[font_codec]-line_vis;
			else
				y=0;
		}
	}
// ---------------
void TReader::fontPlus()
	{
		if(inside_type==0)
		{
			if(font_size<50) font_size++;
			fontChange(true);
		}
	}
	
void TReader::fontMinus()
	{
		if(inside_type==0)
		{
			if(font_size>1) font_size--;
			fontChange(true);
			
			if(num_line[font_codec]<y+line_vis)
			{
				if(num_line[font_codec]>line_vis)
					y=num_line[font_codec]-line_vis;
				else
					y=0;
			}
		}
	}
// ---------------
void TReader::fontBold()
	{
		if(inside_type==0)
		{
			if(font_bold==25)	font_bold=87;
			else				font_bold=25;
		}
	}
	
void TReader::fontItalic()
	{
		if(inside_type==0)
		{
			if(font_ital)	font_ital=false;
			else			font_ital=true;
		}
	}
// ---------------
void TReader::fontCodec()
	{
		font_codec++;
		if (font_codec>=codec_num) font_codec=0;
	}
// ---------------
void TReader::Rotate90()
	{
		if(rotate_90)	rotate_90=false;
		else			rotate_90=true;
		fontChange(true);
		
		if(num_line[font_codec]<y+line_vis)
		{
			if(num_line[font_codec]>line_vis)
				y=num_line[font_codec]-line_vis;
			else
				y=0;
		}
	}
	
void TReader::Inside()
	{
		inside_type++;
		if (inside_type>=2) inside_type=0;
		
		if(finish_open)
			open=true;
		finish_open=true;
	}
/*
void TReader::editorAdd()
	{
		editor_add=false;
		for(int i=0;i<=num_line[font_codec];i++)
		{
			tEditor->addText(text[font_codec][i]+"\n");
		}
	}*/

void TReader::keyPressEvent(QKeyEvent* k)	//keyReleaseEvent
	{		
		switch(k->key())
		{
			case 4115:// (Up)
				if(!rotate_90)	line_up=true;
				else			move_left=true;
			break;
				
			case 50:
				if(!rotate_90)	line_up=true;
				else			move_left=true;
			break;
			
			case 4117:// (Down)
				if(!rotate_90)	line_down=true;
				else			move_right=true;
			break;
				
			case 56:
				if(!rotate_90)	line_down=true;
				else			move_right=true;
			break;
			
			case 4114:// (left)
				if(!rotate_90)	move_left=true;
				else			line_down=true;
			break;
				
			case 52:
				if(!rotate_90)	move_left=true;
				else			line_down=true;
			break;
			
			case 4116:// (right)
				if(!rotate_90)	move_right=true;
				else			line_up=true;
			break;
				
			case 54:
				if(!rotate_90)	move_right=true;
				else			line_up=true;
			break;
// ---------------------------------			
			case 4118:// (vol+) 
				pageUp();
			break;
			
			case 4119:// (vol-)
				pageDown();
			break;
// ------------			
			case 49:// (1)
				fontMinus();
			break;
			
			case 51:// (3)
				fontPlus();
			break;
// ------------	
			case 35:// (#)
				fontBold();
			break;
			
			case 42:// (*)
				fontItalic();
			break;
// ------------		
			case 55:// (7)
				fontCodec();
			break;
			
			case 57://(9)
				Rotate90();
			break;
			
			case 48:
				Inside();
			break;
// ----------------------------
			case 4146:// (c)
				tEditor->memo->clear();
				tEditor->addText(text[font_codec][y]+"\n");
				tEditor->show();
			break;
// ----------------------------
			case 4145://(exit)
				exit=true;
			break;
			
			default:
			break;
		}
	}
	
void TReader::keyReleaseEvent(QKeyEvent* k)	//keyReleaseEvent
	{
		switch(k->key())
		{
			case 4115:// (Up)
				if(!rotate_90)	line_up=false;
				else			move_left=false;
			break;
				
			case 50:				
				if(!rotate_90)	line_up=false;
				else			move_left=false;
			break;
			
			case 4117:// (Down)
				if(!rotate_90)	line_down=false;
				else			move_right=false;
			break;
				
			case 56:
				if(!rotate_90)	line_down=false;
				else			move_right=false;
			break;	
			
			case 4114:// (left)
				if(!rotate_90)	move_left=false;
				else			line_down=false;
			break;
				
			case 52:
				if(!rotate_90)	move_left=false;
				else			line_down=false;
			break;
			
			case 4116:// (right)
				if(!rotate_90)	move_right=false;
				else			line_up=false;
			break;
				
			case 54:
				if(!rotate_90)	move_right=false;
				else			line_up=false;
			break;
			
			default:
			break;
		}
	}
	
void TReader::fontChange(int font_chng)
	{
		
		if(font_chng)
		{
			line_step=font_size+2;
		
			if(!rotate_90)
			{
				line_vis=310/line_step;
				line_vis_px=line_vis*316;
			}
			else
			{
				line_vis=230/line_step;
				line_vis_px=line_vis*236;
			}
		}		
		//if(line_vis_px<num_line[font_codec])
			scroll_size=line_vis_px/num_line[font_codec];
		//else
		//	scroll_size=1;
	}
	
void TReader::openFile(QString tfile, int type)
	{
		qDebug("File: "+tfile);
		open=false;finish_open=false;
		y=0;
		QStringList clear;
		text[0]=text[1]=clear;
		
		QFont font("KolertsFont", font_size, font_bold, font_ital);
		setFont(font);
		QFontMetrics fm(font);
		QString line[2];
		QString temp;
		
		QFile file(tfile);
		if( file.open(IO_ReadOnly) )		
		{
			QTextStream stream( &file );
			num_line[0]=num_line[1]=0;
			while (!stream.eof() && !exit && !finish_open)
			{
				line[0]=stream.readLine();
				//tEditor->addText(line[0]+"\n");
				///text_edit+=line[0]+"\n";
				line[1]=ANSI(line[0]);
				line[0]=UTF(line[0]);
				
				for(int codec=0;codec<codec_num;codec++)
				{
					if(type==0)
					{
						text[codec].append(line[codec]);
						num_line[codec]++;
					}
					
					if(type==1)
					{
						x=5;
						int width=221;
						if(rotate_90) width=301;
						int len=0;
						int pos=0;
						int maxWidth = width;
						int posTo=0;
						int spasePos=0;
						int spaseLen=0;
						
						int length=line[codec].length();
						if(length==0)
						{
							num_line[codec]++;
							text[codec].append("");
						}						
						while ( pos < length )
						{
							posTo = line[codec].find('\n',pos);
							
							if ( posTo < 0 )
								posTo = length;
							
							spasePos = pos;
							spaseLen = 0;
							len=0;
							for (int i=pos; i<posTo; i++)
							{
								len += fm.width( line[codec][i] );

								if ( line[codec][i] == ' ' )
								{
									spasePos = i;
									spaseLen = len;
								}				
								if ( len > maxWidth )
								{
									if ( spasePos == pos )
									{
										text[codec].append(line[codec].mid(pos, i-pos+1 ));
										pos = i+1;
										len = 0;
										spaseLen = 0;
									} else
									{
										text[codec].append(line[codec].mid( pos, spasePos-pos ));
										pos = spasePos+1;
										len = len-spaseLen;
									}
									spasePos = pos;
									num_line[codec]++;
								}
							}
							if  ( pos != posTo )
							{
								text[codec].append(line[codec].mid(pos,posTo-pos));
								num_line[codec]++;
							}
							pos = posTo+1;
						}
					}
				}
				fontChange(false);
				qApp->processEvents();
			}
			QTextStream edit_stream( &file );
			file.close();			
		}
		else 
		{
			font_color=QColor(200,0,0);
			font_size=16;
			text[0]=text[1]="Error: can`t open "+tfile;
			num_line[0]=num_line[1]=1;
		}
		
		if(rotate_chk)
		{
			matrix.translate(239, 0); 
			matrix.rotate(90);
			rotate_chk=false;
		}
		fontChange(false);
		
		if(finish_open)
		{
			open=true;
			finish_open=false;
		}
		else
			finish_open=true;
	}

void TReader::paintAbout()
	{
		QFont ftitle("KolertsFont",27,87,false);
		QFont font("KolertsFont",15,10,false);
		
		QPainter p;	
		p.begin( p_field ,this);
		p.setBrush(QColor(250,250,250));
		p.setPen(QColor(250,250,250));
		p.drawRect(0, 0, 240, 320);
		p.setBrush(Qt::black);
		p.setPen(Qt::black);
		
		p.drawRect(1, 1, 238, 318);
		
		p.drawPixmap(7, 46, about_icon);	
		
		p.setFont(ftitle);
		p.setPen(QColor(255,100,12));
		p.drawText(57, 72, title, -1, QPainter::RTL);
		
		p.setFont(font);
		p.setPen(Qt::white);
		p.drawText(59, 88, text1, -1, QPainter::RTL);
		
		p.drawText(7, 140, text2, -1, QPainter::RTL);
		p.drawText(7, 165, text3, -1, QPainter::RTL);
		p.drawText(7, 260, text4, -1, QPainter::RTL);
		p.end();		
		
		bitBlt( this, 0, 0, p_field );	
		
		if(exit_count<=0) qApp->quit();
		exit_count--;
	}
	
QString TReader::getProgramDir ( const QString &AFileName )
	{
		QString str = AFileName;
		int i = str.findRev ( "/" );
		str.remove ( i+1, str.length() - i );
		return str;
	}
	
QString TReader::getFmDir()
{
	exit=true;
	QString fm_path="/mmc/mmca1/.system/QTDownLoad/fm/";
	
	if (QFile(fm_path).exists())
		exit=false;
	else
	{
		fm_path="/ezxlocal/.system/QTDownLoad/fm/";
		if (QFile(fm_path).exists())
			exit=false;
		else
			fm_path="ERORR! cant found FsMan";
	}
	
	qDebug("fm_path=\""+fm_path+"\"");

	return fm_path;
}

void TReader::action()
	{
		if(!edit)
		{			
			if (line_up) 	lineUp();
			if (line_down)	lineDown();
			if (move_left) 	moveLeft();
			if (move_right)	moveRight();
		}		
		
		if (!exit)		TextBrowse();
		else 			paintAbout();
		if(open)		openFile(UTF(FileName), inside_type);
		//if(editor_add)	editorAdd();
	}
	
int main( int argc, char **argv )
{
	ZApplication* a = new ZApplication( argc, argv );	
	TReader* treader = new TReader();
   	a->setMainWidget( treader );
	   	treader->show();
	int ret = a->exec();
	delete treader;
	delete a;
   	return ret;
}
